package 
{
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.events.MouseEvent;
  import flash.display.Graphics;
  import flash.text.TextField;
  import flash.text.TextFormat;
    
  public class Rect1 extends Sprite {
    private var px:int;
    private var py:int;
    private var pw:int;
    private var ph:int;
    private var g:Graphics;
    private var text_field:TextField;
    private var main:Main;

    public function Rect1(main:Main, px:int = 0, py:int = 0, pw:int = 0, ph:int = 0) {
      this.main = main;

      this.px = px;
      this.py = py;
      this.pw = pw;
      this.ph = ph;

      g = this.graphics;

      this.draw();

      text_field = new TextField();
      var format:TextFormat = new TextFormat();
      format.size = 30;
      text_field.defaultTextFormat = format;

      text_field.selectable = false; 

      addChild(text_field);

      this.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
      this.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
      this.addEventListener(MouseEvent.MOUSE_UP, onMouseUp); 
    }

    public function setX(px:int):void { this.px = px;}
    public function setY(py:int):void { this.py = py;}
    public function getX():int { return this.px;}
    public function getY():int { return this.py;}
    public function setButtonText(str:String):void {
      text_field.text = str;
      text_field.x = this.px + (pw - text_field.textWidth) / 2;
      text_field.y = this.py + (ph - text_field.textHeight) / 2;
      text_field.width = 100;
      text_field.height = 50;
    }

    public function draw(color:int = 0xFFFFFF):void {
      g.lineStyle(2, 0x000000, 1.0);
      g.beginFill(color, 1.0);
      g.drawRoundRect(this.px, this.py, this.pw, this.ph, 20, 20);
      g.endFill();
    }      

    private function onMouseDown(event:MouseEvent):void {
      this.draw(0x000000);
      text_field.textColor = 0xFFFFFF;
    }

    private function onMouseOut(event:MouseEvent):void {
      this.draw();
      text_field.textColor = 0x000000;
    }

    private function onMouseUp(event:MouseEvent):void {
      this.draw();
      text_field.textColor = 0x000000;

      main.push();
    }
  }
}
