/*
*   Flash  <policy-file-request/> ɑ΂
*   port 843 ŕԓT[o[vO
*   hCƃ|[gԍ XMLĂ
*
*   gcc pserv.c
*/

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#define PORT 843
#define BUFFER_SIZE 256

int main(){
  int result;
  unsigned short port = PORT;
  int srcSocket;
  int dstSocket;

  struct sockaddr_in srcAddr;
  struct sockaddr_in dstAddr;
  int dstAddrSize = sizeof(dstAddr);

  memset(&srcAddr, 0, sizeof(srcAddr));
  srcAddr.sin_port = htons(port);
  srcAddr.sin_family = AF_INET;
  srcAddr.sin_addr.s_addr = htonl(INADDR_ANY);

  /* socket */
  srcSocket = socket(AF_INET, SOCK_STREAM, 0);

  if(srcSocket == -1){
    printf("socket error\n");
    return -1;
  }

  /* bind */
  result = bind(srcSocket, (struct sockaddr *)&srcAddr, sizeof(srcAddr));

  if(result == -1){
    printf("bind error\n");
    return -1;
  }

  /* listen */
  result = listen(srcSocket, 1);

  if(result == -1){
    printf("listen error\n");
    return -1;
  }

  while(1){
    int numrcv;
    char buffer[BUFFER_SIZE + 10];

    /* accept */
    dstSocket = accept(srcSocket, (struct sockaddr *)&dstAddr, &dstAddrSize);

    if(dstSocket == -1){
      printf("accept error\n");
      continue;
    }

    /* recv */
    numrcv = recv(dstSocket, buffer, BUFFER_SIZE, 0);

    if(buffer[0] == '<' && buffer[1] == 'p'){
      /* XML */
      char *str_xml = "<?xml version=\"1.0\"?>\n<!DOCTYPE cross-domain-policy SYSTEM \"http://www.macromedia.com/xml/dtds/cross-domain-policy.dtd\">\n<cross-domain-policy>\n    <allow-access-from domain=\"127.0.0.1\" to-ports=\"40002\"/>\n</cross-domain-policy>";

      /* send */
      send(dstSocket, str_xml, strlen(str_xml), 0);
      printf("send str_xml\n");
    }
    else{
      printf("error recieve:%s\n", buffer);
    }

    close(dstSocket);
  }
}
